/* *****************************************************************************
 *
 * Description: This class allows you to do and undo two String
 * operations: append() and replace().
 *
 * Examples:
 *   java-introcs LineEdit 
 *   COS ROCKS
 *   COS ROX
 *   COS ROX!!
 *   COS ROX
 *   COS ROCKS
 **************************************************************************** */

public class LineEdit {
    // instance variables
    private String line;     // current line
    // need one more instance variable ...
    // hint: what data structure can be used to keep LIFO history?

   // create a new LineEdit with given initial text
   public LineEdit(String text) {
       // initialize all instance variables

   }
   
   // get the current state of the editor
   public String toString() {
       return line;

   }
   
   // add the given text at the end of the line
   public void append(String text) {
       // first save the current line

       // then append the text to create the new line
       
   }
   
   // replace all occurrences of "from" with "to"
   public void replace(String from, String to) {
       // first save the current line

       // then replace using the String method: .replaceAll(from, to);
       // e.g., "ready".replaceAll("dy", "ch") returns "reach"
   }
   
   // undo the latest append/replace operation that hasn't already been undone
   public void undo() {
       // restore most recent line


   }
   
   // test client
   public static void main(String[] args) {
      LineEdit line = new LineEdit("COS ROCKS");
      System.out.println(line);
   
      line.replace("CKS", "X");
      System.out.println(line);
   
      line.append("!!");
      System.out.println(line);
      
      line.undo();
      System.out.println(line);
   
      line.undo();
      System.out.println(line);
   }
}
